using System;
using System.Drawing;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace Sample {
	public class TextureImage {
		Device device;
		private VertexBuffer vertex;
		private Texture texture;
		
		public TextureImage(Device device, int width, int height, string bitmapfilename)
			: this(device, width, height, new Bitmap(bitmapfilename))
		{
		}
		public TextureImage(Device device, int width, int height, Bitmap bitmap) {
			this.device = device;
			vertex = new VertexBuffer(typeof(CustomVertex.TransformedTextured), 6, device, Usage.None, CustomVertex.TransformedTextured.Format, Pool.Managed);
			Array array = vertex.Lock(0, LockFlags.None);
			array.SetValue(new CustomVertex.TransformedTextured(0, 0, 0, 1, 0, 0), 0);
			array.SetValue(new CustomVertex.TransformedTextured(width, 0, 0, 1, 1, 0), 1);
			array.SetValue(new CustomVertex.TransformedTextured(0, height, 0, 1, 0, 1), 2);
			array.SetValue(new CustomVertex.TransformedTextured(width, 0, 0, 1, 1, 0), 3);
			array.SetValue(new CustomVertex.TransformedTextured(width, height, 0, 1, 1, 1), 4);
			array.SetValue(new CustomVertex.TransformedTextured(0, height, 0, 1, 0, 1), 5);
			vertex.Unlock();
			texture = Texture.FromBitmap(device, bitmap, Usage.None, Pool.Managed);
		}
		
		public void DrawTexture() {
			device.SetTexture(0, texture);
			device.SetStreamSource(0, vertex, 0);
			device.VertexFormat = CustomVertex.TransformedTextured.Format;
			device.DrawPrimitives(PrimitiveType.TriangleList, 0, 2);
		}
	}
}
