using System.Drawing;
using System.Windows.Forms;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace Sample {
	public class Window : Form {
		private const int width = 640;
		private const int height = 480;
		private Device device;
		private TextureImage image;
		
		public Window() {
			// Form̊eݒ
			Text = "Direct3D with Managed DirectX";
			FormBorderStyle = FormBorderStyle.Fixed3D;
			MaximizeBox = false;
			StartPosition = FormStartPosition.CenterScreen;
			ClientSize = new Size(width, height);
			BackColor = Color.White;
			SetStyle(ControlStyles.AllPaintingInWmPaint | ControlStyles.Opaque, true);
			
			DisplayMode mode = Manager.Adapters[0].CurrentDisplayMode;
			
			// DeviceIuWFNgɓnp[^
			PresentParameters pp = new PresentParameters();
			pp.Windowed = false;
			pp.BackBufferCount = 1;
			pp.BackBufferFormat = mode.Format;
			pp.BackBufferWidth = width;
			pp.BackBufferHeight = height;
			pp.SwapEffect = SwapEffect.Discard;
			
			// DeviceIuWFNg̐
			try {
				// n[hEFAɂ郉X^CYA_
				device = new Device(0, DeviceType.Hardware, this, CreateFlags.HardwareVertexProcessing, pp);
			} catch (DirectXException) {
				try {
					// n[hEFAɂ郉X^CYA\tgEFAɂ钸_
					device = new Device(0, DeviceType.Hardware, this, CreateFlags.SoftwareVertexProcessing, pp);
				} catch (DirectXException) {
					try {
						// \tgEFAɂ郉X^CYA_
						device = new Device(0, DeviceType.Reference, this, CreateFlags.SoftwareVertexProcessing, pp);
					} catch (DirectXException e) {
						MessageBox.Show(e.Message, "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
						Close();
					}
				}
			}
			
			// J[\
			System.Windows.Forms.Cursor.Hide();
			
			// rbg}bv̓ǂݍ
			Bitmap bitmap = new Bitmap("hello.bmp");
			image = new TextureImage(device, width, height, bitmap);
		}
		
		protected override void OnPaint(PaintEventArgs e) {
			base.OnPaint(e);
			
			device.Clear(ClearFlags.Target, Color.White, 0, 0);
			device.BeginScene();
			image.DrawTexture();
			device.EndScene();
			device.Present();
		}
		
		protected override void Dispose(bool disposing) {
			if (disposing) {
				if (device != null)  {
					// DeviceIuWFNǧЕt
					device.Dispose();
				}
			}
			base.Dispose(disposing);
		}
		
		protected override void OnKeyDown(KeyEventArgs e) {
			base.OnKeyDown(e);
			// EscapeL[ŏI
			if (e.KeyCode == Keys.Escape) {
				Close();
			}
		}
	}
}
